---
updatedAt: 2026-08-13T11:04:20.000Z
agentTools:
  projectIndex: https://docs.picsart.io/llms.txt
---

# Upload files

Upload resources such as videos, audios or images. The provided URL can be passed as inputs to video operation.


<Tabs>
  <Tab title="Limitations">
    * Supported source video formats are WEBM, MP4 and MOV.
    * Supported source audio formats are tbd.
    * Supported source image formats are JPG, PNG and WEBP.
    * The input file cannot be bigger than 100MB.
    * The maximum resolution at the input should not be bigger than 1920x1080.
  </Tab>

  <Tab title="Authorization">
    Accessing our powerful API requires an API key. Make sure it's included in your request header `X-Picsart-API-Key` for smooth authorization.
  </Tab>
</Tabs>

# OpenAPI definition

```json
{
  "openapi": "3.0.0",
  "info": {
    "version": "1.0",
    "title": "Picsart Programmable Video APIs",
    "description": "[Official technical documentation portal](https://docs.picsart.io/)\n[Developer Guidelines](https://picsart.io/terms)\n"
  },
  "servers": [
    {
      "url": "https://video-api.picsart.io/v1",
      "description": "Production"
    }
  ],
  "paths": {
    "/upload": {
      "post": {
        "summary": "Upload files",
        "operationId": "video-upload",
        "description": "Upload resources such as videos, audios or images. The provided URL can be passed as inputs to video operation.\n",
        "requestBody": {
          "content": {
            "multipart/form-data": {
              "schema": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/UploadParameters"
                  }
                ]
              }
            }
          }
        },
        "tags": [
          "Utilities"
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/200"
          },
          "400": {
            "$ref": "#/components/responses/400"
          },
          "401": {
            "$ref": "#/components/responses/401"
          },
          "403": {
            "$ref": "#/components/responses/403"
          },
          "404": {
            "$ref": "#/components/responses/404"
          },
          "405": {
            "$ref": "#/components/responses/405"
          },
          "413": {
            "$ref": "#/components/responses/413"
          },
          "415": {
            "$ref": "#/components/responses/415"
          },
          "429": {
            "$ref": "#/components/responses/429"
          },
          "431": {
            "$ref": "#/components/responses/431"
          },
          "500": {
            "$ref": "#/components/responses/500"
          },
          "503": {
            "$ref": "#/components/responses/503"
          },
          "529": {
            "$ref": "#/components/responses/529"
          }
        }
      }
    }
  },
  "security": [
    {
      "apiKey": []
    }
  ],
  "components": {
    "schemas": {
      "UploadParameters": {
        "type": "object",
        "properties": {
          "file": {
            "description": "Source file (binary).",
            "nullable": false,
            "type": "string",
            "format": "binary"
          }
        },
        "required": [
          "file"
        ]
      },
      "Error": {
        "type": "object",
        "properties": {
          "message": {
            "type": "string"
          },
          "detail": {
            "type": "string"
          }
        },
        "required": [
          "detail"
        ]
      },
      "401_Error": {
        "type": "object",
        "properties": {
          "code": {
            "type": "integer",
            "example": 401
          },
          "message": {
            "type": "string",
            "example": "Unauthorized"
          },
          "detail": {
            "type": "string"
          }
        },
        "required": [
          "detail"
        ]
      }
    },
    "responses": {
      "200": {
        "description": "Success.",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "data": {
                  "type": "object",
                  "properties": {
                    "id": {
                      "type": "string",
                      "nullable": true
                    },
                    "url": {
                      "type": "string",
                      "format": "uri",
                      "nullable": false
                    }
                  }
                },
                "status": {
                  "type": "string",
                  "enum": [
                    "success",
                    "error",
                    "processing",
                    "queued"
                  ],
                  "nullable": false
                }
              }
            },
            "example": {
              "status": "success",
              "data": {
                "id": "75c68cf6-9881-46a5-a3e8-6907640901eb",
                "url": "https://cdn.picsart.io/d04d0fd0-192f-4532-bd9a-aa63a728e39c.mp4"
              }
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "400": {
        "description": "Bad Request",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "401": {
        "description": "Unauthorized",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/401_Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "403": {
        "description": "Forbidden",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "404": {
        "description": "Not Found",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "405": {
        "description": "Method Not Allowed",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "413": {
        "description": "Request Entity Too Large",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "415": {
        "description": "Unsupported Media Type",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "429": {
        "description": "Too Many Requests",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "431": {
        "description": "Request Header Fields Too Large",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "500": {
        "description": "Internal Server Error",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "503": {
        "description": "Service Unavailable",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      },
      "529": {
        "description": "Overloaded. The model provider is overloaded and could not complete this request. Please retry shortly, or switch to a different model.\n",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/Error"
            }
          }
        },
        "headers": {
          "X-Picsart-Correlation-Id": {
            "schema": {
              "type": "string"
            },
            "description": "The id which will help for troubleshooting request chain in the system."
          },
          "X-Picsart-Ratelimit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The number of available calls within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Limit": {
            "schema": {
              "type": "integer"
            },
            "description": "The total number of requests that can be done within the timeframe. See the X-Picsart-Ratelimit-Reset-Time."
          },
          "X-Picsart-Ratelimit-Reset-Time": {
            "schema": {
              "type": "integer"
            },
            "description": "The time when the used request count resets and the number of available calls gets equal to the total number."
          },
          "X-Picsart-Credit-Available": {
            "schema": {
              "type": "integer"
            },
            "description": "The remaining number of the credits on the balance."
          }
        }
      }
    },
    "securitySchemes": {
      "apiKey": {
        "type": "apiKey",
        "in": "header",
        "name": "X-Picsart-API-Key"
      }
    }
  }
}
```